<?php
if (!defined('DC_RC_PATH')) { return; }

$__autoload['imgWidthHeightAdder'] = dirname(__FILE__).'/inc/class.imgWidthHeightAdder.php';
$__autoload['iwahaMedia'] = dirname(__FILE__).'/inc/class.iwahaMedia.php';

/* Add behavior callback, will be used for all types of posts (standard, page, galery item, ...) */
$core->addBehavior('coreAfterPostContentFormat',array('iwahaAdminBehaviors','afterPostFormat'));

/* Add behavior for the checkbox in the admin preferences */
$core->addBehavior('adminBlogPreferencesForm',array('iwahaAdminBehaviors','adminBlogPreferencesForm'));
$core->addBehavior('adminBeforeBlogSettingsUpdate',array('iwahaAdminBehaviors','adminBeforeBlogSettingsUpdate'));

class iwahaAdminBehaviors {
	public static function afterPostFormat($ref) {
		$GLOBALS['core']->blog->settings->addNamespace('iwaha');
		if (!$GLOBALS['core']->blog->settings->iwaha->iwaha_enabled) {
			return;
		}

		$post_excerpt_xhtml = $ref['excerpt_xhtml'];
		$post_content_xhtml = $ref['content_xhtml'];

		imgWidthHeightAdder::updatePostEntries(array(
			'excerpt_xhtml' => &$post_excerpt_xhtml,
			'content_xhtml' => &$post_content_xhtml
		));

		if ($post_excerpt_xhtml != $ref['excerpt_xhtml'] || $post_content_xhtml != $ref['content_xhtml']) {
			$ref['excerpt_xhtml'] = $post_excerpt_xhtml;
			$ref['content_xhtml'] = $post_content_xhtml;
		}
	}

	public static function adminBlogPreferencesForm($core,$settings)
	{
		$core->blog->settings->addNamespace('iwaha');
		echo
		'<div class="fieldset"><h4>IWaHa (Img Width and Height adder)</h4>'.
		'<p><label class="classic">'.
		form::checkbox('iwaha_enabled','1',$settings->iwaha->iwaha_enabled).
		__('Add width and height attributes to images in posts.').'</label></p>'.
		'</div>';
	}

	public static function adminBeforeBlogSettingsUpdate($settings)
	{
		$settings->addNameSpace('iwaha');
		$settings->iwaha->put('iwaha_enabled',!empty($_POST['iwaha_enabled']),'boolean');
	}
}
