<?php
class imgWidthHeightAdder {
	protected static $post_imgs = array();
	protected static $post_imgs_reg = '#(?:<img[^>]+src="(.+?)".*?>)#msu';

	public static function updatePostEntries($ref) {
		global $core;
		if (@is_array($ref)) {
			/* Add image sizes for excerpt (XHTML) */
			if (isset($ref['excerpt_xhtml'])) {
				$excerpt = &$ref['excerpt_xhtml'];
				if ($excerpt) {
					// Find every image
					if (preg_match_all(self::$post_imgs_reg,$excerpt,$m) > 0)
					{
						foreach ($m[1] as $i => $v) {
							self::$post_imgs[$v] = array(
								'w' => null,
								'h' => null
							);
						}

						// Lookup the size for each image found
						$media = new iwahaMedia($core);
						$media->getMediaItems(self::$post_imgs);

						// Add size information to every img tag
						$excerpt = preg_replace_callback(self::$post_imgs_reg, array('self', 'photoSize'), $excerpt);
					}
				}
			}

			/* Add image sizes for content (XHTML) */
			if (isset($ref['content_xhtml'])) {
				$content = &$ref['content_xhtml'];
				if ($content) {
					// Find every image
					if (preg_match_all(self::$post_imgs_reg,$content,$m) > 0)
					{
						foreach ($m[1] as $i => $v) {
							self::$post_imgs[$v] = array(
								'w' => null,
								'h' => null
							);
						}

						// Lookup the size for each image found
						$media = new iwahaMedia($core);
						$media->getMediaItems(self::$post_imgs);

						// Add size information to every img tag
						$content = preg_replace_callback(self::$post_imgs_reg, array('self', 'photoSize'), $content);
					}
				}
			}
		}
	}

	protected static function photoSize($match)
	{
		if (!self::$post_imgs[$match[1]]['w']) {
			return $match[0];
		}

		if (strpos($match[0], 'width=') !== FALSE || strpos($match[0], 'height=') !== FALSE) {
			return $match[0];
		}

		$img = self::$post_imgs[$match[1]];
		$width = $img['w'];
		$height = $img['h'];

		$s = preg_replace('#(<img[^>]+src="[^"]+?".*?)/>#msu', '$1'.' height="'.$height.'" width="'.$width.'" />', $match[0]);
		return $s;
	}

}
